//
// nono
// Copyright (C) 2021 nono project
// Licensed under nono-license.txt
//

//
// シリアルポートの標準入出力ドライバ
//

#pragma once

#include "comdriver.h"
#include "autofd.h"
#include <termios.h>

class COMDriverStdio : public COMDriver
{
	using inherited = COMDriver;
 public:
	COMDriverStdio(HostDevice *hostdev_);
	~COMDriverStdio() override;

	bool InitDriver() override;
	int Dispatch(int udata) override;
	int Read() override;
	void Write(uint32 data) override;

 private:
	struct termios oldtc {};
	char char_from_signal {};

	autofd sigfd {};
};
