//
// nono
// Copyright (C) 2021 nono project
// Licensed under nono-license.txt
//

//
// MAC アドレス
//

#pragma once

#include "header.h"
#include <array>

// MAC アドレス格納用のクラス
class macaddr_t : public std::array<uint8, 6>
{
	using inherited = std::array<uint8, 6>;
 public:
	// この MAC アドレスが 00:00:00:00:00:00 なら true
	bool Empty() const;

	// MAC アドレスを適当に生成する。
	void Generate();

	// 文字列から MAC アドレスを作成する。"HH:HH:HH:HH:HH:HH" 形式のみ。
	// 成功すれば true を返す。
	bool FromString(const std::string& src);

	// 区切り文字なしの文字列形式を返す。主に ROM 埋め込み用で英字は大文字。
	// 01:23:AB なら "0123AB" のような感じ。
	std::string ToString() const;

	// sep を区切り文字とする文字列形式を返す。主に表示用で英字は小文字。
	// 01:23:AB で sep = ":" なら "01:23:ab" のような感じ。
	std::string ToString(char sep) const;
};
