//
// nono
// Copyright (C) 2020 nono project
// Licensed under nono-license.txt
//

#pragma once

#include "device.h"

class AreaSetDevice : public IODevice
{
	using inherited = IODevice;

	static const int baseaddr = 0xe86000;

 public:
	AreaSetDevice();
	virtual ~AreaSetDevice() override;

	void ResetHard(bool poweron) override;

	uint64 Read8(uint32 addr) override;
	uint64 Read16(uint32 addr) override;
	uint64 Write8(uint32 addr, uint32 data) override;
	uint64 Write16(uint32 addr, uint32 data) override;
	uint64 Peek8(uint32 addr) override;

 private:
	uint8 limit {};
};

extern AreaSetDevice *gAreaSet;
