//
// nono
// Copyright (C) 2020 nono project
// Licensed under nono-license.txt
//

//
// CRTC-II (HD6445)
//

#pragma once

#include "device.h"
#include "event.h"

class CRTC2Device : public IODevice
{
	using inherited = IODevice;
 public:
	CRTC2Device();
	virtual ~CRTC2Device() override;

	void ResetHard(bool poweron) override;

 protected:
	// BusIO インタフェース
	static const uint32 NPORT = 2;
	uint64 Read(uint32 offset);
	uint64 Write(uint32 offset, uint32 data);
	uint64 Peek(uint32 offset);

 private:
	// 垂直表示期間イベント
	void VDispCallback(Event& ev);

	// アドレスレジスタ
	int ar {};

	// レジスタ
	uint8 reg[40] {};

	Event vdisp_event { this };
};

extern CRTC2Device *gCRTC2;
