//
// nono
// Copyright (C) 2020 nono project
// Licensed under nono-license.txt
//

//
// イベント
//

#include "event.h"
#include "scheduler.h"

// コンストラクタ
Event::Event()
{
}

// コンストラクタ (dev 指定あり)
Event::Event(Device *dev_)
	: Event()
{
	dev = dev_;
}

// デストラクタ
Event::~Event()
{
}

// イベントを登録する
void
Event::Regist()
{
	gScheduler->RegistEvent(*this);
}

// 名前をセットして、イベントを登録する (便利関数)
void
Event::Regist(const std::string& name_)
{
	SetName(name_);
	Regist();
}

// 名前をセットする
void
Event::SetName(const std::string& val)
{
	name = val;
	if (name.length() > 25) {
		dev->putmsgn("Event Name \"%s\" is too long(%d chars)",
			name.c_str(), (int)name.length());
		name.resize(25);
	}
}
