//
// nono
// Copyright (C) 2020 nono project
// Licensed under nono-license.txt
//

//
// FuseROM
//

#pragma once

#include "device.h"

class FuseROMDevice : public IODevice
{
	using inherited = IODevice;

	// この ROM が保持できるデータ量 (バイト数換算)
	static const uint32 SRCBYTES = 128;
 public:
	FuseROMDevice();
	virtual ~FuseROMDevice() override;

	bool Init() override;

 protected:
	// BusIO インタフェース
	static const uint32 NPORT = SRCBYTES * 2;	// XXX 未調査
	uint64 Read(uint32 offset);
	uint64 Write(uint32 offset, uint32 data);
	uint64 Peek(uint32 offset);

 private:
	// バイトデータで保持しておく
	uint8 src[SRCBYTES] {};
};

extern FuseROMDevice *gFuseROM;
