//
// nono
// Copyright (C) 2020 nono project
// Licensed under nono-license.txt
//

//
// GVRAM
//

#pragma once

#include "device.h"

class GVRAMDevice : public IODevice
{
	using inherited = IODevice;
	static const uint baseaddr = 0xc0'0000;
 public:
	GVRAMDevice();
	virtual ~GVRAMDevice() override;

	uint64 Read8(uint32 addr) override;
	uint64 Read16(uint32 addr) override;
	uint64 Write8(uint32 addr, uint32 data) override;
	uint64 Write16(uint32 addr, uint32 data) override;
	uint64 Peek8(uint32 addr) override;

 private:
	std::unique_ptr<uint8[]> mem {};
};

extern GVRAMDevice *gGVRAM;
