//
// nono
// Copyright (C) 2022 nono project
// Licensed under nono-license.txt
//

//
// NWS-1750 のキーボードコントローラ(予定地)
//

// デバイスが存在しないことをバスエラーで検出できないので、
// とりあえず用意して生返事だけさせておく。

#include "kbc.h"

// グローバル参照用
KBCDevice *gKBC;

// コンストラクタ
KBCDevice::KBCDevice()
	: inherited("Keyboard Ctlr")
{
}

// デストラクタ
KBCDevice::~KBCDevice()
{
	gKBC = NULL;
}

uint64
KBCDevice::Read8(uint32 addr)
{
	// XXX 折り返しは不明
	switch (addr & 7) {
	 case KEYDATA:
		return 0;

	 case KEYSTAT:
		return 0xc0;	// KBRDY, MSRDY

	 case KEYINTE:
		return 0;		// ?

	 case KEYRESET:
		return 0xff;	// ?

	 case KEYBUZZ:
		return 0xff;	// ?

	 case MSDATA:
		return 0;

	 case MSINTE:		// ?
		return 0;

	 case MSRESET:		// ?
		return 0xff;

	 default:
		return 0xff;
	}
}

uint64
KBCDevice::Write8(uint32 addr, uint32 data)
{
	// とりあえず全無視
	return 0;
}

uint64
KBCDevice::Peek8(uint32 addr)
{
	// XXX 未実装
	return 0xff;
}
