//
// nono
// Copyright (C) 2022 nono project
// Licensed under nono-license.txt
//

//
// NWS-1750 のキーボードコントローラ(予定地)
//

#pragma once

#include "device.h"

class KBCDevice : public IODevice
{
	using inherited = IODevice;

	// レジスタ
	static const uint32 KEYDATA		= 0;
	static const uint32 KEYSTAT		= 1;
	static const uint32 KEYINTE		= 2;
	static const uint32 KEYRESET	= 3;
	static const uint32 KEYBUZZ		= 4;
	static const uint32 MSDATA		= 5;
	static const uint32 MSINTE		= 6;
	static const uint32 MSRESET		= 7;

 public:
	KBCDevice();
	~KBCDevice() override;

	uint64 Read8(uint32 addr) override;
	uint64 Write8(uint32 addr, uint32 data) override;
	uint64 Peek8(uint32 addr) override;
};

extern KBCDevice *gKBC;
