//
// nono
// Copyright (C) 2022 nono project
// Licensed under nono-license.txt
//

//
// NEWS の I/O 空間担当
//

#pragma once

#include "device.h"
#include <array>

class NewsIODevice : public IOContainerDevice
{
	using inherited = IOContainerDevice;
 public:
	NewsIODevice();
	~NewsIODevice() override;

	bool Init() override;

	uint64 Read8(uint32 addr) override;
	uint64 Read16(uint32 addr) override;
	uint64 Read32(uint32 addr) override;
	uint64 Write8(uint32 addr, uint32 data) override;
	uint64 Write16(uint32 addr, uint32 data) override;
	uint64 Write32(uint32 addr, uint32 data) override;
	uint64 Peek8(uint32 addr) override;

 protected:
	IODevice *GetDevice(uint32 addr) const override;

 private:
	inline IODevice *SearchDevice(uint32 addr) const;

	std::unique_ptr<Device> pEthernet {};
	std::unique_ptr<Device> pKBC {};
	std::unique_ptr<Device> pRTC {};
	std::unique_ptr<Device> pSCC {};
	std::unique_ptr<Device> pSubRAM {};
	std::unique_ptr<Device> pNopIO {};

	// デバイステーブル
	std::array<IODevice *, 64> table {};
};

extern NewsIODevice *gNewsIO;
