//
// nono
// Copyright (C) 2020 nono project
// Licensed under nono-license.txt
//

//
// OPM (YM2151)
//

#pragma once

#include "device.h"
#include "event.h"

class OPMDevice : public IODevice
{
	using inherited = IODevice;

	static const int baseaddr = 0xe90000;
	static const uint64 clk = 250_nsec;		// 4MHz

 public:
	OPMDevice();
	virtual ~OPMDevice() override;

	void ResetHard(bool poweron) override;

 protected:
	// BusIO インタフェース
	static const uint32 NPORT = 2;
	uint64 Read(uint32 offset);
	uint64 Write(uint32 offset, uint32 data);
	uint64 Peek(uint32 offset);

 private:
	bool IsBusy() const;

	int reg {};		// アクセスレジスタ番号

	uint64 busy_origin;		// BUSY の起点時刻
	uint64 busy_start;		// BUSY のアサート開始時刻
	uint64 busy_end;		// BUSY のアサート終了時刻
};

extern OPMDevice *gOPM;
