//
// nono
// Copyright (C) 2020 nono project
// Licensed under nono-license.txt
//

//
// LUNA* の RAM のうち 16MB に満たないメモリブロックを担当する人
//

#pragma once

#include "device.h"

class PartialRAMDevice : public IOContainerDevice
{
	using inherited = IOContainerDevice;
 public:
	PartialRAMDevice();
	virtual ~PartialRAMDevice() override;

	bool Init() override;

	uint64 Read8(uint32 addr) override;
	uint64 Read16(uint32 addr) override;
	uint64 Read32(uint32 addr) override;
	uint64 Write8(uint32 addr, uint32 data) override;
	uint64 Write16(uint32 addr, uint32 data) override;
	uint64 Write32(uint32 addr, uint32 data) override;
	uint64 Peek8(uint32 addr) override;

 protected:
	IODevice *GetDevice(uint32 addr) const override;

 private:
	inline IODevice *SearchDevice(uint32 addr) const;

	uint32 ram_size {};

	IODevice *ramdev {};
	IODevice *nopdev {};
};

extern PartialRAMDevice *gPartialRAM;
