//
// nono
// Copyright (C) 2020 nono project
// Licensed under nono-license.txt
//

//
// LUNA-I の ROM エミュレーション
//

#pragma once

#include "romemu_luna.h"

class Luna1PROMEmuDevice : public LunaPROMEmuDevice
{
	using inherited = LunaPROMEmuDevice;

 public:
	Luna1PROMEmuDevice();
	virtual ~Luna1PROMEmuDevice() override;

	bool Init() override;

 private:
	uint32 ROM_Init() override;
	uint32 ROM_Entry() override;
	void ROM_Close() override;
	void Command() override;

	void CommandG(const std::vector<std::string>& arg);
	void CommandGH();
	void CommandK(const std::vector<std::string>& arg);
	bool CommandKInput(const std::string& val);
	void CommandX();

	// NVRAM
	bool InitNVRAM();
	void GetNVRAM(bootinfo_t&);

	// 'x' コマンドなら true。
	bool x_executed {};

	// 'g' コマンドで読み込んだプログラムのエントリポイント。
	// なければ 0。'x' コマンドで使う。
	uint32 x_entrypoint {};

	// プロンプトの状態。
	// 0 が通常プロンプト。
	// 1 以降は k コマンドのプロンプトを示す
	int prompt_idx {};
};
