//
// nono
// Copyright (C) 2020 nono project
// Licensed under nono-license.txt
//

//
// サブメモリ
//

#pragma once

#include "device.h"

class SubRAMDevice : public IODevice
{
	using inherited = IODevice;
 public:
	SubRAMDevice(uint ramsize_kb);
	virtual ~SubRAMDevice() override;

	uint64 Read8(uint32 addr) override;
	uint64 Read16(uint32 addr) override;
	uint64 Read32(uint32 addr) override;
	uint64 Write8(uint32 addr, uint32 data) override;
	uint64 Write16(uint32 addr, uint32 data) override;
	uint64 Write32(uint32 addr, uint32 data) override;
	uint64 Peek8(uint32 addr) override;
	uint64 Poke8(uint32 addr, uint32 data) override;

 private:
	// アドレスデコーダ
	uint64 Decoder(uint32 addr) const;

	std::unique_ptr<uint8[]> ram {};
	uint ramsize {};
};

extern SubRAMDevice *gSubRAM;
