//
// nono
// Copyright (C) 2020 nono project
// Licensed under nono-license.txt
//

//
// TAS ポート
//

#pragma once

#include "device.h"
#include <atomic>

class TASDevice : public IODevice
{
	using inherited = IODevice;
 public:
	TASDevice();
	virtual ~TASDevice() override;

	void ResetHard(bool poweron) override;

 protected:
	// BusIO インタフェース
	static const uint32 NPORT = 1;
	uint64 Read(uint32 offset);
	uint64 Write(uint32 offset, uint32 data);
	uint64 Peek(uint32 offset);

 private:
	std::atomic<uint8> tas {};	// bit 7 のみ有効。
};

extern TASDevice *gTAS;
