//
// nono
// Copyright (C) 2020 nono project
// Licensed under nono-license.txt
//

//
// VM (X68030)
//

#pragma once

#include "vm.h"

class VM_X68030 final : public VM
{
	using inherited = VM;
 public:
	VM_X68030();
	~VM_X68030() override;

	// MPU の RESET 命令によるリセット
	void ResetByMPU() override;

 protected:
	// ブートページを切り替える。
	void SwitchBootPage(Device *parent, bool isrom) override;

 private:
	std::unique_ptr<Device> pHuman68k {};
	std::unique_ptr<Device> pIPLROM0 {};
	std::unique_ptr<Device> pXIOSpace {};
};
