//
// nono
// Copyright (C) 2022 nono project
// Licensed under nono-license.txt
//

//
// 逆アセンブルウィンドウ
//

#pragma once

#include "wxsubwindow.h"
#include "wxbutton.h"
#include "wxmonitor.h"
#include "disasm.h"
#include <array>

class WXDisasmWindow : public WXSubWindow
{
	using inherited = WXSubWindow;

 public:
	WXDisasmWindow(wxWindow *parent, int idx_);
	virtual ~WXDisasmWindow() override;

	bool Layout() override;
	void FontChanged() override;

 private:
	// テキスト入力イベント
	void OnTextEnter(wxCommandEvent& event);

	// ボタンイベント
	void OnPrevLine(wxCommandEvent& event);
	void OnPrevPage(wxCommandEvent& event);
	void OnNextLine(wxCommandEvent& event);
	void OnNextPage(wxCommandEvent& event);

	// マウスイベント
	void OnMouseWheel(wxMouseEvent& event);

	// アドレス欄を更新
	void UpdateAddr();

	// コントロール
	wxTextCtrl *addrctrl {};
	std::array<WXButton *, 4> buttons {};

	// コントロールパネルを格納する sizer
	wxBoxSizer *ctrlbox {};

	// コントロールパネル部分の長さ
	int fixed_height {};

	WXMonitorPanel *screen {};

	// 逆アセンブラウィンドウは複数枚あるので自分がそのうちの何番目か。
	int idx {};

	// 逆アセンブラ
	DisasmMonitor *disasm {};

	int inst_bytes {};		// 1命令の(最小)バイト数
	uint32 inst_mask {};	// その時のマスク

	// イベントテーブル
	wxDECLARE_EVENT_TABLE();
};
