//
// nono
// Copyright (C) 2020 nono project
// Licensed under nono-license.txt
//

//
// バージョンダイアログ
//

#pragma once

#include "wxnono.h"
#include "monitor.h"

// バージョンダイアログ
class WXVersionDlg : public wxDialog
{
	using inherited = wxDialog;
 public:
	WXVersionDlg(wxWindow *parent);
	virtual ~WXVersionDlg() override;
};

// ホスト情報モニタ
class HostInfoMonitor : public Object
{
	using inherited = Object;
 public:
	HostInfoMonitor();
	virtual ~HostInfoMonitor() override;
	operator bool() const { return aut; }

	Monitor monitor { this };

 private:
	DECLARE_MONITOR_CALLBACK(MonitorUpdate);

	wxString osname {};
	wxString machinename {};
	wxString wxname {};
	uint32 aut;
};

extern HostInfoMonitor *gHostInfo;
